require "yaml"
class WDBFile
  def initialize(file)
    @records = Hash.new
    io = File.open(file)
    io.binmode
    load(io)
  end
  def load(io)
    header = io.read(4)
    if not header.eql?("BDIW") 
      raise "Invalid file!"
    end
    @records = Hash.new
	  io.read(16)
    while not io.eof?
      itemID = io.read(4).unpack("i")[0]
	    recSize = io.read(4).unpack("i")[0]
	    io.read(12)
	    itemName = read_string(io)
	    unless itemName.nil?
	      io.read(3)
        io.read(16)
	      value = io.read(4).unpack("i")[0]
	      io.read(recSize - 12 - itemName.length - 4 - 16 - 4)
	      @records[itemID] = [ value, itemName ]
	      puts "#{itemID}, #{value}, #{itemName}"
	    end
    end
  end
  def length()
    return @record_count
  end
  def each
    @records.each do |r|
      yield r
    end
  end
  def get_record(id)
    return @records[id]
  end
  private
  def read_string(io)
    c = ""
    string = ""
    begin 
      if io.eof? 
        return nil
      end
      c = io.read(1)
      if c != "\0"
        string = string + "#{c}"
      end
    end while c != "\0"
    return string
  end
end

WDBFile.new("itemcache.wdb")
